Plug can send webhooks for notable events. For example, this could include if a new statement is available or we notice a credential is now resulting in login failure.
Listening to webhooks is preferred over polling since it notifies your integration immediately when the event happens and reduces the load on our API.
You may specify the webhook URLs that you would like the events to be POSTed to by clicking into a business unit's details in the Dashboard from the Business units page and editing the Webhooks panel.
When sending a webhook, Arcadia looks for a 2xx response. If such a response is not received within 10 seconds after the connection is made, Arcadia assumes that the webhook failed to deliver and the Arcadia platform will continue to attempting to send the webhook response three times every six hours for a total of one day (twelve automatic retries maximum). Each subsequent webhook attempt will have an identical message body.
There is an optional isInteractive boolean flag when creating new credentials. If this is set to true, a webhookUrl is required, and the system will emit Real-Time-Credential-Notification (RTCV) webhook notifications confirming REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS or REAL_TIME_CREDENTIAL_VALIDATION_FAILURE event types. This will also emit pending status notifications. These webhooks are only retried up to three times.
There are endpoints for viewing and resending the webhooks stored in the system here.
Webhook Payloads
The data object we include in the webhook payload is the same data that is returned for that resource normally in the API, if that resource has endpoints. If your integration only needs that information, you can avoid making additional API calls to get the data.
For STATEMENT webhooks for both event type EXISTING_DATA_UPDATED and NEW_DATA_AVAILABLE webhooks, the data object in the webhook body will show the same values as what's returned from the summarized statement endpoint rather than the detailed statement endpoint.
Business Units
The business units feature is currently in beta testing
Each business unit may have its own live webhook URL and sandbox webhook URL.
When an entity triggers a webhook, that webhook is sent to each of the entity's related business units (the union across related accounts) and all of those business units' ancestors, if those business units have the corresponding live or sandbox webhook URLs configured. A distinct webhook ID is created for each URL, and the sending of each is independent; the payloads are identical aside from the webhook ID.
The payload of every webhook also includes a businessUnitIds array. This array contains the directly-related business units for the webhook. It does not include the ancestor business units that also receive the webhook.
The list and retrieve webhooks endpoints also enforce business unit access rules: a user can only access webhooks created for business units they have access to.
For more information on business units, see the feature guide.
Webhook Parameters
It is possible to optionally specify additional parameters that will be sent along with all webhooks. Namely, you can set the value of any custom headers or query parameters. This can be useful for authentication purposes to verify that a webhook is coming from Arcadia.
Currently, these values must be set by Arcadia internally and cannot be set via the API or Dashboard. To set up these values, please reach out to customer support via Zendesk and let them know what header name(s) and value(s) are required. The maximum length of the header name is 80 characters, and the maximum length of the header value is 255 characters. Both can only contain alphanumeric characters, as well as _ and - characters. The header value can additionally contain the special characters /, ., \, and ,. Spaces are not allowed. The values for the headers and query parameters are shared across all business units for your organization.
Processing Only the Webhooks You Care About
Arcadia does not currently support opting in or out of individual webhook event types; all webhook URLs you have configured will receive all event types. Instead, your integration should filter for the webhooks it cares about after receiving them using the top-level resource and eventType fields.
If a webhook's resource and eventType are not relevant to your integration, you do not need to process it any further. Just respond with a 2xx status code so Arcadia knows the webhook was received and should not be reattempted.
If the webhook is relevant to your needs, handle it and then respond with a 2xx status code once you've finished processing it successfully. However, if your processing takes longer than 10 seconds, please respond with 2xx first and then process the webhook asynchronously.
See below for a complete list of webhook event types with example JSON payloads:
Webhooks Relevant for All Integrations
| Event Type | Resource Types | Description |
|---|---|---|
STATUS_CHANGE | ACCOUNT / CREDENTIAL / FILE / DELETION / DOWNLOAD / METER | Arcadia will send this webhook for all status and status detail updates for Credentials, Accounts, Files, Downloads, and Meters. This includes account and meter voiding. |
EXISTING_DATA_UPDATED | STATEMENT / DISCOVERED_STATEMENT / METER | Arcadia will send this webhook for any updates made to a statement that has already been discovered and stored, or when new interval data is available for a Meter. For statements, Arcadia typically updates existing data when there is a minor update to our data extraction logic. You can expect the statement ID and / or the uploaded bill ID for the statement to remain the same while the data will slightly change. |
NEW_DATA_AVAILABLE | STATEMENT / DISCOVERED_STATEMENT | Arcadia will send this webhook when a new statement has been discovered for the first time. You can expect to get the latest statement data after receiving this webhook. Arcadia considered adjustment statements to be new statements with their own new and unique statement ID. |
Webhooks ONLY Relevant for Building Your Own "Connect"
| Event Type | Resource Type | Description |
|---|---|---|
REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS | CREDENTIAL | This webhook will only be sent for credentials that supports real time credential validation and Arcadia has successfully logged into the utility account. |
REAL_TIME_CREDENTIAL_VALIDATION_FAILURE | CREDENTIAL | This webhook will only be sent for credentials that supports real time credential validation and Arcadia has failed to log into the utility account. |
Webhooks Exclusive to Interval Customers
| Event Type | Resource Types | Description |
|---|---|---|
NEW_DATA_AVAILABLE | METER | Arcadia will send this webhook when a new Meter has been discovered for the first time. Usually, the status will be INTERVALS_NOT_REQUESTED and interval extraction must be requested unless you have opted into instant intervals or auto meter activation. In some circumstances, the status will be INTERVALS_SUCCESS and the earliestIntervalAt and latestIntervalAt fields will already be set. |
EXISTING_DATA_UPDATED | METER | Arcadia will send this webhook when new interval data is available and the earliestIntervalAt or latestIntervalAt fields are updated. The earliestModifiedIntervalAt field indicates the earliest interval timestamp that changed as part of this update. |
STATUS_CHANGE | METER | Arcadia will send this webhook when the status field on a Meter changes. When changing to INTERVALS_SUCCESS, the earliestIntervalAt and latestIntervalAt fields will also be updated. This also fires when a meter is voided (or unvoided). |
Webhooks Relevant for Business Units
If your integration makes use of business units, these webhooks can help with automatically managing the business unit assignments for your accounts. For more information on business units, see the feature guide.
| Event Type | Resource Type | Description |
|---|---|---|
BUSINESS_UNIT_ASSIGNMENT | ROOT_BUSINESS_UNIT_ACCOUNT | Arcadia will send this webhook when an account is assigned to the root business unit. This can be caused by new account creation, manual assignment, or business unit deletion. Helpful for indicating when an admin should review an account's assigned business units. This webhook is dispatched only to the root business unit's webhook URL. |
DATA_DELETED | BUSINESS_UNIT_DELETION | Arcadia will send this webhook when a user deletes a business unit. Includes information on which business unit the accounts were moved to, and how many accounts were impacted. |
Webhook Notification Examples
The resource embedded in thedatafield will be the same schema as the API response for an entity of the corresponding resource type in theresourcefield
STATUS_CHANGE
{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"alternateAccesses" : [ ],
"businessUnitsUnion" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"connectionHealth" : "CONNECTION_SUCCESS",
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"customerGivenWebsite" : null,
"id" : "crd_0c5d396f-f11c-c76b-9be8-89343463af21",
"isAccessible" : true,
"isActive" : true,
"isCustomerActionRequired" : false,
"isThirdPartyPortal" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "[email protected]",
"lastSuccessfulMultiFactorAuthenticationOptOutAt" : null,
"multiFactorAuthenticationOptOutStatus" : null,
"nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : {
"country" : "USA",
"id" : "prv_41428d0c-2804-ca52-e396-4ef9f30754cb",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"status" : "CONNECTION_SUCCESS",
"statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS",
"totalAccounts" : 1,
"username" : "example-username",
"username2" : null,
"username3" : null,
"username4" : null,
"website" : "https://example.provider.site"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_9ec2fbdc-33ff-13b2-9b97-47d9ee7dcc73",
"resource" : "CREDENTIAL"
}{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountNumber" : "7672119675161980850",
"billingCycle" : "MONTHLY",
"businessUnits" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"customData" : null,
"firstExtractedAt" : "2024-02-21T00:00:00.000+00:00",
"id" : "act_53e41db0-a1a6-227d-dd28-573570cd1312",
"isAccessible" : false,
"isCustomerActionRequired" : false,
"isHistoryFulfilled" : false,
"isIntervalsThirdPartyPortalAccount" : false,
"isStatementsProductActive" : true,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"lastSuccessfulStatementExtractionAt" : "2024-02-21T00:00:00.000+00:00",
"latestNewStatementAt" : "2023-10-14T00:00:00.000+00:00",
"latestStatementDate" : "2023-10-14",
"nextExpectedPostDate" : "2023-11-13",
"normalizedAccountNumber" : "7672119675161980850",
"prepaid" : false,
"provider" : {
"country" : "USA",
"id" : "prv_41428d0c-2804-ca52-e396-4ef9f30754cb",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"providerClassification" : "PUBLISHER",
"serviceTypes" : [ ],
"siteNames" : [ ],
"status" : "NEW_ACCOUNT",
"statusDetail" : "DATA_ACCESSIBLE",
"summaryAccountId" : null,
"summaryAccountNumber" : null,
"totalMeters" : 0,
"type" : "NORMAL",
"voidedAt" : null
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_b5109320-af6e-738b-7088-080a1bdc19da",
"resource" : "ACCOUNT"
}{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountNumbers" : [ ],
"businessUnitsIntersection" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"discoveredStatementId" : null,
"fileName" : "example-file-name.pdf",
"id" : "fil_31706680-327f-9301-3a91-026940d08bb9",
"isCustomerActionRequired" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : null,
"statementDate" : null,
"statementId" : null,
"status" : "QUEUED",
"statusDetails" : [ "READY_FOR_PROCESSING" ],
"transferMethod" : "CLIENT"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_6e0c4dc2-3244-ca56-f1e8-600ccfe7ac52",
"resource" : "FILE"
}{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountCount" : 6,
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"deletionTargetId" : "crd_623a8e26-db9b-df24-fc7a-00688ed41615",
"fileCount" : 0,
"id" : "del_7adde914-8db1-2209-4d35-0780c6395d15",
"meterCount" : 4,
"siteCount" : 0,
"statementCount" : 5,
"status" : "SUCCESS"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_2453f9ec-239a-69e8-d8e8-f988081e7ec8",
"resource" : "DELETION"
}{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"downloadMethod" : "IN_BROWSER",
"id" : "dwl_8d67f209-6a03-6ace-8662-406a4ea35c12",
"status" : "SUCCESS",
"token" : "abcd"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_e3412f4e-0bc4-5468-8e2a-50cbeb8868d0",
"resource" : "DOWNLOAD"
}{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accounts" : [ {
"accountNumber" : "7672119675161980850",
"id" : "act_53e41db0-a1a6-227d-dd28-573570cd1312"
} ],
"bulbType" : null,
"businessUnitsIntersection" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"currentTariff" : null,
"customData" : null,
"earliestIntervalAt" : "2024-01-22T00:00:00.000+00:00",
"generalDescriptionAsPrinted" : null,
"id" : "mtr_768b0644-3f71-4eac-9c04-7f75ed622180",
"isIntervalsDormant" : null,
"isIntervalsProductActive" : true,
"isIntervalsThirdPartyPortalMeter" : false,
"isLocationRecommendationIgnored" : false,
"isStandalone" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"latestIntervalAt" : "2024-02-20T00:00:00.000+00:00",
"latestIntervalsCheckedAt" : null,
"latestStatementDate" : null,
"localTimezone" : "US/Eastern",
"meterConstantMultiplier" : null,
"meterNumber" : "5246692140770003988",
"nextExpectedPostDate" : "2024-03-21",
"normalizedMeterNumber" : "5246692140770003988",
"normalizedPointOfDeliveryNumber" : "",
"pipeType" : null,
"pointOfDeliveryNumber" : "0",
"previousMeterConstantMultiplier" : null,
"previousMeterNumber" : null,
"provider" : null,
"serviceAddress" : null,
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"site" : null,
"status" : "INTERVALS_SUCCESS",
"statusDetail" : "INTERVALS_AVAILABLE",
"voidedAt" : null
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_d4fc5215-607f-e255-b49d-571ed3f44735",
"resource" : "METER"
}
Account voiding
When statement data is extracted incorrectly and later fixed, accounts created from the incorrect data can become voided: a STATUS_CHANGE webhook is sent for the ACCOUNT resource with the voidedAt field set to a non-null timestamp. If the voided account is later found to be correct on a new statement, a subsequent STATUS_CHANGE webhook is sent with voidedAt set back to null.
{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountNumber" : "2589017620420157285",
"billingCycle" : "MONTHLY",
"businessUnits" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"customData" : null,
"firstExtractedAt" : "2024-02-21T00:00:00.000+00:00",
"id" : "act_51e93e04-ac04-8490-6782-eb5da5f76675",
"isAccessible" : false,
"isCustomerActionRequired" : false,
"isHistoryFulfilled" : false,
"isIntervalsThirdPartyPortalAccount" : false,
"isStatementsProductActive" : true,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"lastSuccessfulStatementExtractionAt" : "2024-02-21T00:00:00.000+00:00",
"latestNewStatementAt" : "2023-02-26T00:00:00.000+00:00",
"latestStatementDate" : "2023-02-26",
"nextExpectedPostDate" : "2023-03-28",
"normalizedAccountNumber" : "2589017620420157285",
"prepaid" : false,
"provider" : {
"country" : "USA",
"id" : "prv_41428d0c-2804-ca52-e396-4ef9f30754cb",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"providerClassification" : "PUBLISHER",
"serviceTypes" : [ ],
"siteNames" : [ ],
"status" : "NEW_ACCOUNT",
"statusDetail" : "DATA_ACCESSIBLE",
"summaryAccountId" : null,
"summaryAccountNumber" : null,
"totalMeters" : 0,
"type" : "NORMAL",
"voidedAt" : "2024-03-01T00:00:00.000+00:00"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_42f1c56c-5477-2330-239c-71658eb91487",
"resource" : "ACCOUNT"
}
Meter voiding
When statement data is extracted incorrectly and later fixed, meters created from the incorrect data can become voided: a STATUS_CHANGE webhook is sent for the METER resource with the voidedAt field set to a non-null timestamp. If the voided meter is later found to be correct on a new statement, a subsequent STATUS_CHANGE webhook is sent with voidedAt set back to null.
{
"businessUnitIds" : [ "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accounts" : [ {
"accountNumber" : "5402813417589690145",
"id" : "act_09ac5892-aa33-0ae4-9987-29e36bb06c3c"
} ],
"bulbType" : null,
"businessUnitsIntersection" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_b2d4e1d1-3028-becd-1821-ff80aa8107f5",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"currentTariff" : null,
"customData" : null,
"earliestIntervalAt" : "2024-01-22T00:00:00.000+00:00",
"generalDescriptionAsPrinted" : null,
"id" : "mtr_32f18c9f-71f7-a3dd-83e5-2d15b9a879ea",
"isIntervalsDormant" : null,
"isIntervalsProductActive" : true,
"isIntervalsThirdPartyPortalMeter" : false,
"isLocationRecommendationIgnored" : false,
"isStandalone" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"latestIntervalAt" : "2024-02-20T00:00:00.000+00:00",
"latestIntervalsCheckedAt" : null,
"latestStatementDate" : null,
"localTimezone" : "US/Eastern",
"meterConstantMultiplier" : null,
"meterNumber" : "1958177989734265209",
"nextExpectedPostDate" : "2024-03-21",
"normalizedMeterNumber" : "1958177989734265209",
"normalizedPointOfDeliveryNumber" : "15",
"pipeType" : null,
"pointOfDeliveryNumber" : "15",
"previousMeterConstantMultiplier" : null,
"previousMeterNumber" : null,
"provider" : null,
"serviceAddress" : null,
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"site" : null,
"status" : "INTERVALS_SUCCESS",
"statusDetail" : "INTERVALS_AVAILABLE",
"voidedAt" : "2024-03-01T00:00:00.000+00:00"
},
"errors" : [ ],
"eventType" : "STATUS_CHANGE",
"id" : "whk_1e99d13c-ecac-b2b2-4bee-10dd29f6f089",
"resource" : "METER"
}NEW_DATA_AVAILABLE
{
"businessUnitIds" : [ "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accounts" : [ {
"accountNumber" : "297608951047192936",
"id" : "act_cb3d11c4-77d9-3584-0323-528227642930"
} ],
"bulbType" : null,
"businessUnitsIntersection" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"currentTariff" : null,
"customData" : null,
"earliestIntervalAt" : "2024-01-22T00:00:00.000+00:00",
"generalDescriptionAsPrinted" : null,
"id" : "mtr_ac43dd39-3e63-6216-6e05-3af399d74094",
"isIntervalsDormant" : null,
"isIntervalsProductActive" : true,
"isIntervalsThirdPartyPortalMeter" : false,
"isLocationRecommendationIgnored" : false,
"isStandalone" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"latestIntervalAt" : "2024-02-20T00:00:00.000+00:00",
"latestIntervalsCheckedAt" : null,
"latestStatementDate" : null,
"localTimezone" : "US/Eastern",
"meterConstantMultiplier" : null,
"meterNumber" : "5354766225280947949",
"nextExpectedPostDate" : "2024-03-21",
"normalizedMeterNumber" : "5354766225280947949",
"normalizedPointOfDeliveryNumber" : "14",
"pipeType" : null,
"pointOfDeliveryNumber" : "14",
"previousMeterConstantMultiplier" : null,
"previousMeterNumber" : null,
"provider" : null,
"serviceAddress" : null,
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"site" : null,
"status" : "INTERVALS_SUCCESS",
"statusDetail" : "INTERVALS_AVAILABLE",
"voidedAt" : null
},
"errors" : [ ],
"eventType" : "NEW_DATA_AVAILABLE",
"id" : "whk_5fce4073-6721-4551-c179-0e1872883916",
"resource" : "METER"
}{
"businessUnitIds" : [ "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountData" : [ {
"accountId" : "act_cb3d11c4-77d9-3584-0323-528227642930",
"accountNumber" : "297608951047192936",
"amountDue" : 1519.1,
"dueDate" : "2023-10-09",
"meterData" : [ {
"amountDue" : 463.07,
"currencyCode" : null,
"meterId" : "mtr_74f0f49c-fed7-22b7-fe0c-9fbc087fe8bc",
"meterNumber" : "7687028745763661902",
"meterReadDate" : "2023-09-25",
"normalizedMeterNumber" : "7687028745763661902",
"normalizedPointOfDeliveryNumber" : "16",
"outstandingBalance" : 463.07,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"pointOfDeliveryNumber" : "16",
"previousReadDate" : "2023-08-26",
"serviceType" : "irrigation",
"serviceTypeClassification" : "CORE",
"totalCharges" : 463.07,
"totalUsage" : 991.22,
"totalUsageUnit" : "kWh"
}, {
"amountDue" : 556.63,
"currencyCode" : null,
"meterId" : "mtr_0050e287-eb49-a094-d3e5-8c50ab8fd8c1",
"meterNumber" : "8102285561300676256",
"meterReadDate" : "2023-09-25",
"normalizedMeterNumber" : "8102285561300676256",
"normalizedPointOfDeliveryNumber" : "12",
"outstandingBalance" : 556.63,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"pointOfDeliveryNumber" : "12",
"previousReadDate" : "2023-08-26",
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"totalCharges" : 556.63,
"totalUsage" : 624.78,
"totalUsageUnit" : "kWh"
}, {
"amountDue" : 499.4,
"currencyCode" : null,
"meterId" : "mtr_0111d2c4-ff36-28d1-ccab-4b8630e60eb2",
"meterNumber" : "5090298996868784975",
"meterReadDate" : "2023-09-25",
"normalizedMeterNumber" : "5090298996868784975",
"normalizedPointOfDeliveryNumber" : "15",
"outstandingBalance" : 499.4,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"pointOfDeliveryNumber" : "15",
"previousReadDate" : "2023-08-26",
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"totalCharges" : 499.4,
"totalUsage" : 662.93,
"totalUsageUnit" : "kWh"
} ],
"normalizedAccountNumber" : "297608951047192936",
"outstandingBalance" : 1519.1,
"provider" : {
"classification" : "PUBLISHER",
"id" : "prv_2f574b92-e2e1-f016-d899-ae80dd274773",
"name" : "Example Non-RTCV Provider",
"publisherProviderAccountId" : "act_cb3d11c4-77d9-3584-0323-528227642930"
},
"totalCharges" : 1519.1
} ],
"amountDue" : 1519.1,
"businessUnitsIntersection" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"currencyCode" : null,
"dataIngestionMethod" : "UTILITY_WEBSITE_ACCESS",
"discoveredAt" : "2023-09-25T00:00:00.000+00:00",
"discoveredStatementId" : "dss_2e6bf32d-a2be-2664-684a-391a53917b4f",
"dueDate" : "2023-10-09",
"id" : "stm_aa78d0ff-b500-7bcf-a6a4-c00260a8634e",
"invoiceNumber" : "5775923715923305643",
"isLatestVersion" : true,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"normalizedSummaryAccountNumber" : null,
"outstandingBalance" : 1519.1,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"provider" : {
"country" : "USA",
"id" : "prv_2f574b92-e2e1-f016-d899-ae80dd274773",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"statementDate" : "2023-09-25",
"summaryAccountNumber" : null,
"totalCharges" : 1519.1,
"type" : "BILL",
"versionId" : "stv_0fc5ded2-9f8c-8eaa-b228-b72ac9288d04"
},
"errors" : [ ],
"eventType" : "NEW_DATA_AVAILABLE",
"id" : "whk_303febe9-36e1-eb21-25a6-c886a46cfc91",
"resource" : "STATEMENT"
}{
"businessUnitIds" : [ "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountIds" : [ "act_cb3d11c4-77d9-3584-0323-528227642930" ],
"accountNumbers" : [ "297608951047192936" ],
"businessUnitsIntersection" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2023-09-25T00:00:00.000+00:00",
"credentialIds" : [ ],
"dataIngestionMethod" : null,
"dueDate" : null,
"id" : "dss_5dcb68a7-50be-122a-53a3-59c5577f7395",
"invoiceNumber" : null,
"isLatestVersion" : true,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"provider" : {
"country" : "USA",
"id" : "prv_2f574b92-e2e1-f016-d899-ae80dd274773",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"sourceType" : "PDF",
"statementDate" : "2023-09-25",
"statementId" : null,
"statementType" : "BILL",
"status" : "EXTRACTION_PASSED_QUALITY_CHECKS",
"versionId" : null
},
"errors" : [ ],
"eventType" : "NEW_DATA_AVAILABLE",
"id" : "whk_b29e8a60-e42c-02ca-8494-ff6d6dff6672",
"resource" : "DISCOVERED_STATEMENT"
}{
"businessUnitIds" : [ "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountIds" : [ "act_cb3d11c4-77d9-3584-0323-528227642930" ],
"accountNumbers" : [ "297608951047192936" ],
"businessUnitsIntersection" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_f61f7f99-6a0d-11dd-ef14-d43314604ba6",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2023-09-25T00:00:00.000+00:00",
"credentialIds" : [ ],
"dataIngestionMethod" : null,
"dueDate" : null,
"id" : "dss_be9f1c48-c8a5-ba01-d6d5-df168098cf12",
"invoiceNumber" : null,
"isLatestVersion" : true,
"periodEndDate" : "2023-09-25",
"periodStartDate" : "2023-08-26",
"provider" : {
"country" : "USA",
"id" : "prv_2f574b92-e2e1-f016-d899-ae80dd274773",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"sourceType" : "PDF",
"statementDate" : "2023-09-25",
"statementId" : null,
"statementType" : "BILL",
"status" : "EXTRACTION_FAILED_QUALITY_CHECKS",
"versionId" : null
},
"errors" : [ ],
"eventType" : "NEW_DATA_AVAILABLE",
"id" : "whk_85116ad6-c951-cf67-8210-3b97a6df2e9b",
"resource" : "DISCOVERED_STATEMENT"
}EXISTING_DATA_UPDATED
{
"businessUnitIds" : [ "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accounts" : [ {
"accountNumber" : "9207895340384735758",
"id" : "act_831b8c55-77b6-3341-c922-aa371ad3c2a9"
} ],
"bulbType" : null,
"businessUnitsIntersection" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"currentTariff" : null,
"customData" : null,
"earliestIntervalAt" : "2024-01-22T00:00:00.000+00:00",
"generalDescriptionAsPrinted" : null,
"id" : "mtr_a764bd92-25ba-bcfb-db75-c3e28605dbd6",
"isIntervalsDormant" : null,
"isIntervalsProductActive" : true,
"isIntervalsThirdPartyPortalMeter" : false,
"isLocationRecommendationIgnored" : false,
"isStandalone" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"latestIntervalAt" : "2024-02-20T00:00:00.000+00:00",
"latestIntervalsCheckedAt" : null,
"latestStatementDate" : null,
"localTimezone" : "US/Eastern",
"meterConstantMultiplier" : null,
"meterNumber" : "1384890804112746856",
"nextExpectedPostDate" : "2024-03-21",
"normalizedMeterNumber" : "1384890804112746856",
"normalizedPointOfDeliveryNumber" : "17",
"pipeType" : null,
"pointOfDeliveryNumber" : "17",
"previousMeterConstantMultiplier" : null,
"previousMeterNumber" : null,
"provider" : null,
"serviceAddress" : null,
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"site" : null,
"status" : "INTERVALS_SUCCESS",
"statusDetail" : "INTERVALS_AVAILABLE",
"voidedAt" : null
},
"earliestModifiedIntervalAt" : "2024-02-19T00:00:00.000+00:00",
"errors" : [ ],
"eventType" : "EXISTING_DATA_UPDATED",
"id" : "whk_28e0a301-3c6b-1e56-83fc-b502b45c91a5",
"resource" : "METER"
}{
"businessUnitIds" : [ "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountIds" : [ "act_831b8c55-77b6-3341-c922-aa371ad3c2a9" ],
"accountNumbers" : [ "9207895340384735758" ],
"businessUnitsIntersection" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2023-04-29T00:00:00.000+00:00",
"credentialIds" : [ ],
"dataIngestionMethod" : null,
"dueDate" : null,
"id" : "dss_e4c0b930-16b8-fa93-fba0-ce33dbb97f39",
"invoiceNumber" : null,
"isLatestVersion" : true,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"provider" : {
"country" : "USA",
"id" : "prv_2627a36a-1592-b76a-f996-cf5a68b7900c",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"sourceType" : "PDF",
"statementDate" : "2023-04-29",
"statementId" : null,
"statementType" : "BILL",
"status" : "EXTRACTION_PASSED_QUALITY_CHECKS",
"versionId" : null
},
"errors" : [ ],
"eventType" : "EXISTING_DATA_UPDATED",
"id" : "whk_0b974750-9ab9-2d45-c925-a2ec1fb7c3bd",
"resource" : "DISCOVERED_STATEMENT"
}{
"businessUnitIds" : [ "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountIds" : [ "act_831b8c55-77b6-3341-c922-aa371ad3c2a9" ],
"accountNumbers" : [ "9207895340384735758" ],
"businessUnitsIntersection" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2023-04-29T00:00:00.000+00:00",
"credentialIds" : [ ],
"dataIngestionMethod" : null,
"dueDate" : null,
"id" : "dss_efba657d-749f-b52e-ee21-57147a2a0e3a",
"invoiceNumber" : null,
"isLatestVersion" : true,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"provider" : {
"country" : "USA",
"id" : "prv_2627a36a-1592-b76a-f996-cf5a68b7900c",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"sourceType" : "PDF",
"statementDate" : "2023-04-29",
"statementId" : null,
"statementType" : "BILL",
"status" : "EXTRACTION_FAILED_QUALITY_CHECKS",
"versionId" : null
},
"errors" : [ ],
"eventType" : "EXISTING_DATA_UPDATED",
"id" : "whk_ecd4d3cd-2c07-4de8-bd2d-791d49ed22b0",
"resource" : "DISCOVERED_STATEMENT"
}
Statement versioning and reprocessing
The versionId field (prefixed stv_) in the data object identifies the specific version of the statement's data. Each time a statement is reprocessed, a new versionId is created. The isLatestVersion boolean indicates whether this is the current, canonical version of the statement.
{
"businessUnitIds" : [ "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"accountData" : [ {
"accountId" : "act_831b8c55-77b6-3341-c922-aa371ad3c2a9",
"accountNumber" : "9207895340384735758",
"amountDue" : 1514.11,
"dueDate" : "2023-05-13",
"meterData" : [ {
"amountDue" : 531.76,
"currencyCode" : null,
"meterId" : "mtr_85025f4f-cedc-f133-373c-59a330483371",
"meterNumber" : "4247903589509507241",
"meterReadDate" : "2023-04-29",
"normalizedMeterNumber" : "4247903589509507241",
"normalizedPointOfDeliveryNumber" : "19",
"outstandingBalance" : 531.76,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"pointOfDeliveryNumber" : "19",
"previousReadDate" : "2023-03-30",
"serviceType" : "sewer",
"serviceTypeClassification" : "CORE",
"totalCharges" : 531.76,
"totalUsage" : 60.2,
"totalUsageUnit" : "kWh"
}, {
"amountDue" : 546.75,
"currencyCode" : null,
"meterId" : "mtr_5d5f408c-ca52-8a86-b4d4-4abf897588a6",
"meterNumber" : "6173296884414329807",
"meterReadDate" : "2023-04-29",
"normalizedMeterNumber" : "6173296884414329807",
"normalizedPointOfDeliveryNumber" : "7",
"outstandingBalance" : 546.75,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"pointOfDeliveryNumber" : "7",
"previousReadDate" : "2023-03-30",
"serviceType" : "lighting",
"serviceTypeClassification" : "CORE",
"totalCharges" : 546.75,
"totalUsage" : 748.23,
"totalUsageUnit" : "kWh"
}, {
"amountDue" : 435.6,
"currencyCode" : null,
"meterId" : "mtr_84c8e79f-a69e-60d9-7366-99284d0e6fe1",
"meterNumber" : "4832671085471612303",
"meterReadDate" : "2023-04-29",
"normalizedMeterNumber" : "4832671085471612303",
"normalizedPointOfDeliveryNumber" : "2",
"outstandingBalance" : 435.6,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"pointOfDeliveryNumber" : "2",
"previousReadDate" : "2023-03-30",
"serviceType" : "electric",
"serviceTypeClassification" : "CORE",
"totalCharges" : 435.6,
"totalUsage" : 573.79,
"totalUsageUnit" : "kWh"
} ],
"normalizedAccountNumber" : "9207895340384735758",
"outstandingBalance" : 1514.11,
"provider" : {
"classification" : "PUBLISHER",
"id" : "prv_2627a36a-1592-b76a-f996-cf5a68b7900c",
"name" : "Example Non-RTCV Provider",
"publisherProviderAccountId" : "act_831b8c55-77b6-3341-c922-aa371ad3c2a9"
},
"totalCharges" : 1514.11
} ],
"amountDue" : 1514.11,
"businessUnitsIntersection" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"businessUnitsUnion" : [ {
"id" : "bus_ba9379bd-0ecc-7f23-19dd-716f1ab5ca6f",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"currencyCode" : null,
"dataIngestionMethod" : "UTILITY_WEBSITE_ACCESS",
"discoveredAt" : "2023-04-29T00:00:00.000+00:00",
"discoveredStatementId" : "dss_568f8da7-fa21-64ca-d959-2a3ef73a35dd",
"dueDate" : "2023-05-13",
"id" : "stm_45855fad-08cc-242c-7012-5ab7efcfe0e8",
"invoiceNumber" : "3347448823402337792",
"isLatestVersion" : true,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"normalizedSummaryAccountNumber" : null,
"outstandingBalance" : 1514.11,
"periodEndDate" : "2023-04-29",
"periodStartDate" : "2023-03-30",
"provider" : {
"country" : "USA",
"id" : "prv_2627a36a-1592-b76a-f996-cf5a68b7900c",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"statementDate" : "2023-04-29",
"summaryAccountNumber" : null,
"totalCharges" : 1514.11,
"type" : "BILL",
"versionId" : "stv_c7c6fff3-464e-3bdc-988a-b5f0bb06e052"
},
"errors" : [ ],
"eventType" : "EXISTING_DATA_UPDATED",
"id" : "whk_4cb69778-e864-cd1d-51f1-0bf501c8c56a",
"resource" : "STATEMENT"
}REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS
{
"businessUnitIds" : [ "bus_c65e9551-3c73-5f5e-9e31-ebcb78999294" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"alternateAccesses" : [ ],
"businessUnitsUnion" : [ {
"id" : "bus_c65e9551-3c73-5f5e-9e31-ebcb78999294",
"name" : null
} ],
"connectionHealth" : "CONNECTION_SUCCESS",
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"customerGivenWebsite" : "https://myutility.com",
"id" : "crd_53308bae-d9af-75af-b780-86d13c348d4d",
"isAccessible" : true,
"isActive" : true,
"isCustomerActionRequired" : false,
"isThirdPartyPortal" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "[email protected]",
"lastSuccessfulMultiFactorAuthenticationOptOutAt" : null,
"multiFactorAuthenticationOptOutStatus" : null,
"nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : {
"country" : "USA",
"id" : "prv_f0919a74-b84e-1388-3dce-23bce2f7db19",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : true,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : true,
"name" : "Example RTCV Provider"
},
"status" : "CONNECTION_SUCCESS",
"statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS",
"totalAccounts" : 1,
"username" : "example-username",
"username2" : null,
"username3" : null,
"username4" : null,
"website" : "https://example.provider.site"
},
"errors" : [ ],
"eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS",
"id" : "whk_58ca852d-2d9d-e21b-10d0-303f19ac8bfe",
"resource" : "CREDENTIAL"
}REAL_TIME_CREDENTIAL_VALIDATION_FAILURE
{
"businessUnitIds" : [ "bus_a69fbae6-ce18-6527-58f1-71ceb933fffb" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"alternateAccesses" : [ ],
"businessUnitsUnion" : [ {
"id" : "bus_a69fbae6-ce18-6527-58f1-71ceb933fffb",
"name" : null
} ],
"connectionHealth" : "CONNECTION_FAILURE",
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"customerGivenWebsite" : "https://example.utility.com",
"id" : "crd_83d950f3-dcee-f62a-9688-aa0212c7650b",
"isAccessible" : false,
"isActive" : true,
"isCustomerActionRequired" : true,
"isThirdPartyPortal" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "[email protected]",
"lastSuccessfulMultiFactorAuthenticationOptOutAt" : null,
"multiFactorAuthenticationOptOutStatus" : null,
"nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : {
"country" : "USA",
"id" : "prv_c829956e-40d3-675a-3636-53822907c00f",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : true,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : true,
"name" : "Example RTCV Provider"
},
"status" : "CONNECTION_FAILURE",
"statusDetail" : "INVALID_CREDENTIALS",
"totalAccounts" : 0,
"username" : "example-username",
"username2" : null,
"username3" : null,
"username4" : null,
"website" : "https://example.provider.site"
},
"errors" : [ ],
"eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_FAILURE",
"id" : "whk_d8ca7506-b46c-82b7-6f7a-baa38b1daa0b",
"resource" : "CREDENTIAL"
}MFA_CHALLENGE_METHOD
{
"businessUnitIds" : [ "bus_bd967212-e4a7-a63a-4aa0-b7f5ac0608a6" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"credential" : {
"alternateAccesses" : [ ],
"businessUnitsUnion" : [ {
"id" : "bus_bd967212-e4a7-a63a-4aa0-b7f5ac0608a6",
"name" : null
} ],
"connectionHealth" : "CONNECTION_IN_PROGRESS",
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"customerGivenWebsite" : "https://example.utility.com",
"id" : "crd_863a36ee-3e6e-296a-a9be-ad94dbc24831",
"isAccessible" : true,
"isActive" : true,
"isCustomerActionRequired" : false,
"isThirdPartyPortal" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "[email protected]",
"lastSuccessfulMultiFactorAuthenticationOptOutAt" : null,
"multiFactorAuthenticationOptOutStatus" : null,
"nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : {
"country" : "USA",
"id" : "prv_995249bf-030e-21ca-2ac4-9565befa79c8",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : true,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : true,
"name" : "Example MFA Provider"
},
"status" : "CONNECTION_IN_PROGRESS",
"statusDetail" : "DATA_EXTRACTION_IN_PROGRESS",
"totalAccounts" : 0,
"username" : "example-username",
"username2" : null,
"username3" : null,
"username4" : null,
"website" : "https://example.provider.site"
},
"verificationMethods" : [ {
"identifier" : "1",
"isResubmission" : false,
"name" : "***-***-1234",
"type" : "text"
}, {
"identifier" : "2",
"isResubmission" : false,
"name" : "********@gmail.com",
"type" : "email"
} ]
},
"errors" : [ ],
"eventType" : "MFA_CHALLENGE_METHOD",
"id" : "whk_14d803d4-4b74-a2a6-9016-1584fcd25868",
"resource" : "MFA_METHOD_PROMPT"
}MFA_CHALLENGE_CODE
{
"businessUnitIds" : [ "bus_5ab42908-c08f-260c-466c-49a3904a86eb" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"credential" : {
"alternateAccesses" : [ ],
"businessUnitsUnion" : [ {
"id" : "bus_5ab42908-c08f-260c-466c-49a3904a86eb",
"name" : null
} ],
"connectionHealth" : "CONNECTION_IN_PROGRESS",
"correlationId" : "example-correlation-id",
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "[email protected]",
"customerGivenWebsite" : "https://example.utility.com",
"id" : "crd_cd239080-2163-6767-8ad6-e808ded79978",
"isAccessible" : true,
"isActive" : true,
"isCustomerActionRequired" : false,
"isThirdPartyPortal" : false,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "[email protected]",
"lastSuccessfulMultiFactorAuthenticationOptOutAt" : null,
"multiFactorAuthenticationOptOutStatus" : null,
"nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00",
"provider" : {
"country" : "USA",
"id" : "prv_ba5b8226-3f62-723b-7eb7-f66e75b69f07",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : true,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : true,
"name" : "Example MFA Provider"
},
"status" : "CONNECTION_IN_PROGRESS",
"statusDetail" : "DATA_EXTRACTION_IN_PROGRESS",
"totalAccounts" : 0,
"username" : "example-username",
"username2" : null,
"username3" : null,
"username4" : null,
"website" : "https://example.provider.site"
},
"isResubmission" : false,
"selectedVerificationMethod" : {
"identifier" : "1",
"isResubmission" : false,
"name" : "***-***-1234",
"type" : "other"
}
},
"errors" : [ ],
"eventType" : "MFA_CHALLENGE_CODE",
"id" : "whk_18aac5da-4a63-efad-b0a2-ce8a734d8c87",
"resource" : "MFA_CODE_PROMPT"
}BUSINESS_UNIT_ASSIGNMENT
{
"businessUnitIds" : [ "bus_aa694b4a-750b-560b-d023-00dd43e5c2da" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"account" : {
"accountNumber" : "8764490131042558851",
"billingCycle" : "MONTHLY",
"businessUnits" : [ {
"id" : "bus_aa694b4a-750b-560b-d023-00dd43e5c2da",
"name" : null
} ],
"correlationIds" : [ "example-correlation-id" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"createdBy" : "system",
"customData" : null,
"firstExtractedAt" : "2024-02-21T00:00:00.000+00:00",
"id" : "act_02e0642e-e303-f82e-fd8a-47c5dc3bcab3",
"isAccessible" : false,
"isCustomerActionRequired" : false,
"isHistoryFulfilled" : false,
"isIntervalsThirdPartyPortalAccount" : false,
"isStatementsProductActive" : true,
"lastModifiedAt" : "2024-02-21T00:00:00.000+00:00",
"lastModifiedBy" : "system",
"lastSuccessfulStatementExtractionAt" : "2024-02-21T00:00:00.000+00:00",
"latestNewStatementAt" : "2023-12-19T00:00:00.000+00:00",
"latestStatementDate" : "2023-12-19",
"nextExpectedPostDate" : "2024-01-18",
"normalizedAccountNumber" : "8764490131042558851",
"prepaid" : false,
"provider" : {
"country" : "USA",
"id" : "prv_d0016689-deec-e5b2-0e46-7a79441b364e",
"intervalServiceTypes" : [ ],
"isIntervalDataSupported" : false,
"isIntervalFileUploadSupported" : false,
"isRealTimeCredentialValidationSupported" : false,
"name" : "Example Non-RTCV Provider"
},
"providerClassification" : "PUBLISHER",
"serviceTypes" : [ ],
"siteNames" : [ ],
"status" : "NEW_ACCOUNT",
"statusDetail" : "DATA_ACCESSIBLE",
"summaryAccountId" : null,
"summaryAccountNumber" : null,
"totalMeters" : 0,
"type" : "NORMAL",
"voidedAt" : null
},
"rootAssignmentTrigger" : "DISCOVERED"
},
"errors" : [ ],
"eventType" : "BUSINESS_UNIT_ASSIGNMENT",
"id" : "whk_113281b3-06d3-61d5-6b8a-5c8369f58cd1",
"resource" : "ROOT_BUSINESS_UNIT_ACCOUNT"
}DATA_DELETED
{
"businessUnitIds" : [ "bus_fb71b140-b933-9c35-4a40-3aca987b6583" ],
"createdAt" : "2024-02-21T00:00:00.000+00:00",
"data" : {
"businessUnitId" : "bus_69dc6270-0dbe-cd39-cadf-40f83ecfd416",
"deletedAt" : "2024-02-21T00:00:00.000+00:00",
"movedToBusinessUnitId" : "bus_fb71b140-b933-9c35-4a40-3aca987b6583",
"totalAccountsMoved" : 4
},
"errors" : [ ],
"eventType" : "DATA_DELETED",
"id" : "whk_7606ece6-91cc-757d-b8bc-df676985fcfc",
"resource" : "BUSINESS_UNIT_DELETION"
}Example Scenarios
Successful RTCV Submission
-
Credentials submitted
-
Optionally, credential login event emitted:
This is only emitted if the credential was submitted using"isInteractive": true,via this endpoint.{ "businessUnitIds" : [ "bus_7deecc71-d661-e518-25fe-100cc022ce54" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_7deecc71-d661-e518-25fe-100cc022ce54", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_fba74f1a-e301-9ed3-b47b-f99bc64bd4c2", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_5ce49928-4246-305b-6f4b-3b9c3922dda3", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS", "id" : "whk_f6225bfe-353b-1697-d62e-2c7843027745", "resource" : "CREDENTIAL" } -
Credential event emitted:
{ "businessUnitIds" : [ "bus_7deecc71-d661-e518-25fe-100cc022ce54" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_7deecc71-d661-e518-25fe-100cc022ce54", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_fba74f1a-e301-9ed3-b47b-f99bc64bd4c2", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_5ce49928-4246-305b-6f4b-3b9c3922dda3", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_6e2ab4d6-260d-42f5-e4c6-ea3c1c689256", "resource" : "CREDENTIAL" } -
Account(s) discovered
-
Account event(s) emitted (1 per account under the credential):
{ "businessUnitIds" : [ "bus_7deecc71-d661-e518-25fe-100cc022ce54" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "accountNumber" : "6021682325865033155", "billingCycle" : "MONTHLY", "businessUnits" : [ { "id" : "bus_7deecc71-d661-e518-25fe-100cc022ce54", "name" : null } ], "correlationIds" : [ "example-correlation-id" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "system", "customData" : null, "firstExtractedAt" : "2024-02-21T00:00:00.000+00:00", "id" : "act_5cdc07a9-643a-1f3d-3b4b-e5d8125a0d07", "isAccessible" : true, "isCustomerActionRequired" : false, "isHistoryFulfilled" : false, "isIntervalsThirdPartyPortalAccount" : false, "isStatementsProductActive" : true, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "system", "lastSuccessfulStatementExtractionAt" : "2024-02-21T00:00:00.000+00:00", "latestNewStatementAt" : "2023-01-04T00:00:00.000+00:00", "latestStatementDate" : "2023-01-04", "nextExpectedPostDate" : "2023-02-03", "normalizedAccountNumber" : "6021682325865033155", "prepaid" : false, "provider" : { "country" : "USA", "id" : "prv_5ce49928-4246-305b-6f4b-3b9c3922dda3", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "providerClassification" : "PUBLISHER", "serviceTypes" : [ { "serviceType" : "irrigation", "serviceTypeClassification" : "CORE" }, { "serviceType" : "natural_gas", "serviceTypeClassification" : "CORE" }, { "serviceType" : "sewer", "serviceTypeClassification" : "CORE" } ], "siteNames" : [ ], "status" : "NEW_ACCOUNT", "statusDetail" : "DATA_ACCESSIBLE", "summaryAccountId" : null, "summaryAccountNumber" : null, "totalMeters" : 6, "type" : "NORMAL", "voidedAt" : null }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_e69f86a0-1a42-81dc-c851-fbdbb88e5603", "resource" : "ACCOUNT" }If this account resolves to only the organization's root business unit, aROOT_BUSINESS_UNIT_ACCOUNT/BUSINESS_UNIT_ASSIGNMENTwebhook will also be emitted. See New Account Assigned to Root Business Unit. -
Statement(s) discovered
-
Statement event(s) emitted (1 per statement):
{ "businessUnitIds" : [ "bus_7deecc71-d661-e518-25fe-100cc022ce54" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "accountData" : [ { "accountId" : "act_5cdc07a9-643a-1f3d-3b4b-e5d8125a0d07", "accountNumber" : "6021682325865033155", "amountDue" : 1227.17, "dueDate" : "2023-01-18", "meterData" : [ { "amountDue" : 479.8, "currencyCode" : null, "meterId" : "mtr_7d5a5a94-7941-b5e7-c2aa-9ae54a4379e0", "meterNumber" : "4046530018604366846", "meterReadDate" : "2023-01-04", "normalizedMeterNumber" : "4046530018604366846", "normalizedPointOfDeliveryNumber" : "19", "outstandingBalance" : 479.8, "periodEndDate" : "2023-01-04", "periodStartDate" : "2022-12-05", "pointOfDeliveryNumber" : "19", "previousReadDate" : "2022-12-05", "serviceType" : "natural_gas", "serviceTypeClassification" : "CORE", "totalCharges" : 479.8, "totalUsage" : 729.63, "totalUsageUnit" : "kWh" }, { "amountDue" : 154.82, "currencyCode" : null, "meterId" : "mtr_a8b24dc8-610a-098c-7522-f53b4eebf549", "meterNumber" : "8726920205939578882", "meterReadDate" : "2023-01-04", "normalizedMeterNumber" : "8726920205939578882", "normalizedPointOfDeliveryNumber" : "18", "outstandingBalance" : 154.82, "periodEndDate" : "2023-01-04", "periodStartDate" : "2022-12-05", "pointOfDeliveryNumber" : "18", "previousReadDate" : "2022-12-05", "serviceType" : "irrigation", "serviceTypeClassification" : "CORE", "totalCharges" : 154.82, "totalUsage" : 254.49, "totalUsageUnit" : "kWh" }, { "amountDue" : 592.55, "currencyCode" : null, "meterId" : "mtr_8b2ce3d1-86cf-8724-311c-28adc899dfe3", "meterNumber" : "7314819864478536947", "meterReadDate" : "2023-01-04", "normalizedMeterNumber" : "7314819864478536947", "normalizedPointOfDeliveryNumber" : "2", "outstandingBalance" : 592.55, "periodEndDate" : "2023-01-04", "periodStartDate" : "2022-12-05", "pointOfDeliveryNumber" : "2", "previousReadDate" : "2022-12-05", "serviceType" : "sewer", "serviceTypeClassification" : "CORE", "totalCharges" : 592.55, "totalUsage" : 102.95, "totalUsageUnit" : "kWh" } ], "normalizedAccountNumber" : "6021682325865033155", "outstandingBalance" : 1227.17, "provider" : { "classification" : "PUBLISHER", "id" : "prv_5ce49928-4246-305b-6f4b-3b9c3922dda3", "name" : "Example RTCV Provider", "publisherProviderAccountId" : "act_5cdc07a9-643a-1f3d-3b4b-e5d8125a0d07" }, "totalCharges" : 1227.17 } ], "amountDue" : 1227.17, "businessUnitsIntersection" : [ { "id" : "bus_7deecc71-d661-e518-25fe-100cc022ce54", "name" : null } ], "businessUnitsUnion" : [ { "id" : "bus_7deecc71-d661-e518-25fe-100cc022ce54", "name" : null } ], "correlationIds" : [ "example-correlation-id" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "currencyCode" : null, "dataIngestionMethod" : "UTILITY_WEBSITE_ACCESS", "discoveredAt" : "2023-01-04T00:00:00.000+00:00", "discoveredStatementId" : "dss_3ca4c373-38ee-3846-f6d0-7f49f6a0517f", "dueDate" : "2023-01-18", "id" : "stm_e28f64d8-1a66-2dd8-ca9e-45f246158d52", "invoiceNumber" : "3266156076587938839", "isLatestVersion" : true, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "normalizedSummaryAccountNumber" : null, "outstandingBalance" : 1227.17, "periodEndDate" : "2023-01-04", "periodStartDate" : "2022-12-05", "provider" : { "country" : "USA", "id" : "prv_5ce49928-4246-305b-6f4b-3b9c3922dda3", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "statementDate" : "2023-01-04", "summaryAccountNumber" : null, "totalCharges" : 1227.17, "type" : "BILL", "versionId" : "stv_b9f06220-c1a9-d144-0836-7c3cb70753ff" }, "errors" : [ ], "eventType" : "NEW_DATA_AVAILABLE", "id" : "whk_7ea9c967-edd2-5a91-e83b-dfd1e6814f20", "resource" : "STATEMENT" }
Unsuccessful RTCV Submission
-
Credentials submitted
-
Optionally, credential login event emitted:
This is only emitted if the credential was submitted using"isInteractive": true,via this endpoint.{ "businessUnitIds" : [ "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d", "name" : null } ], "connectionHealth" : "CONNECTION_FAILURE", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_3fba3873-1d17-65ce-d8a8-cb86df66a7bb", "isAccessible" : false, "isActive" : true, "isCustomerActionRequired" : true, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_c8f5df44-8a06-4e7d-e308-d7b03374c9b6", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "status" : "CONNECTION_FAILURE", "statusDetail" : "INVALID_CREDENTIALS", "totalAccounts" : 0, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_FAILURE", "id" : "whk_40275c3a-e5a5-67bb-c364-ec3cf350df50", "resource" : "CREDENTIAL" } -
Credential failure or pending event emitted:
A pending event indicates that the data extraction failed for a presumably temporary reason, such as the provider website being down.{ "businessUnitIds" : [ "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d", "name" : null } ], "connectionHealth" : "CONNECTION_FAILURE", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_3fba3873-1d17-65ce-d8a8-cb86df66a7bb", "isAccessible" : false, "isActive" : true, "isCustomerActionRequired" : true, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_c8f5df44-8a06-4e7d-e308-d7b03374c9b6", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "status" : "CONNECTION_FAILURE", "statusDetail" : "INVALID_CREDENTIALS", "totalAccounts" : 0, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_862062e4-dafd-ec64-5d27-fd37be7658b2", "resource" : "CREDENTIAL" }Or
{ "businessUnitIds" : [ "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_03194ac2-aa4a-eec0-aa97-64521f067b8d", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_3fba3873-1d17-65ce-d8a8-cb86df66a7bb", "isAccessible" : false, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_c8f5df44-8a06-4e7d-e308-d7b03374c9b6", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example RTCV Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "PROVIDER_WEBSITE_INACCESSIBLE", "totalAccounts" : 0, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_433e178c-ecbb-5ec8-d6e4-9f8382179d18", "resource" : "CREDENTIAL" }
Successful Non-RTCV Submission
-
Credentials submitted
-
Credential event emitted:
{ "businessUnitIds" : [ "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_dc05db96-aa6d-c284-efe7-dff4902dd85d", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3ac39cf2-fdcf-5efd-1d98-0840559258ab", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : false, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : false, "name" : "Example Non-RTCV Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_b7165965-ef83-3411-c92f-05bbe0ee68b9", "resource" : "CREDENTIAL" } -
Account(s) discovered
-
Account event(s) emitted (1 per account under the credential):
{ "businessUnitIds" : [ "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "accountNumber" : "9101529173037918001", "billingCycle" : "MONTHLY", "businessUnits" : [ { "id" : "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933", "name" : null } ], "correlationIds" : [ "example-correlation-id" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "system", "customData" : null, "firstExtractedAt" : "2024-02-21T00:00:00.000+00:00", "id" : "act_0b2eb6e4-1f53-86cb-9d30-6461536907d6", "isAccessible" : true, "isCustomerActionRequired" : false, "isHistoryFulfilled" : false, "isIntervalsThirdPartyPortalAccount" : false, "isStatementsProductActive" : true, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "system", "lastSuccessfulStatementExtractionAt" : "2024-02-21T00:00:00.000+00:00", "latestNewStatementAt" : "2023-09-24T00:00:00.000+00:00", "latestStatementDate" : "2023-09-24", "nextExpectedPostDate" : "2023-10-24", "normalizedAccountNumber" : "9101529173037918001", "prepaid" : false, "provider" : { "country" : "USA", "id" : "prv_3ac39cf2-fdcf-5efd-1d98-0840559258ab", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : false, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : false, "name" : "Example Non-RTCV Provider" }, "providerClassification" : "PUBLISHER", "serviceTypes" : [ { "serviceType" : "lighting", "serviceTypeClassification" : "CORE" }, { "serviceType" : "sewer", "serviceTypeClassification" : "CORE" } ], "siteNames" : [ ], "status" : "NEW_ACCOUNT", "statusDetail" : "DATA_ACCESSIBLE", "summaryAccountId" : null, "summaryAccountNumber" : null, "totalMeters" : 4, "type" : "NORMAL", "voidedAt" : null }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_2e6a176b-2dba-e494-c0e6-252d52a875f7", "resource" : "ACCOUNT" }If this account resolves to only the organization's root business unit, aROOT_BUSINESS_UNIT_ACCOUNT/BUSINESS_UNIT_ASSIGNMENTwebhook will also be emitted. See New Account Assigned to Root Business Unit. -
Statement(s) discovered
-
Statement event(s) emitted (1 per statement):
{ "businessUnitIds" : [ "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "accountData" : [ { "accountId" : "act_0b2eb6e4-1f53-86cb-9d30-6461536907d6", "accountNumber" : "9101529173037918001", "amountDue" : 1107.59, "dueDate" : "2023-10-08", "meterData" : [ { "amountDue" : 191.68, "currencyCode" : null, "meterId" : "mtr_7820bc40-e330-2c18-3601-a87755c8d526", "meterNumber" : "5858584224475859193", "meterReadDate" : "2023-09-24", "normalizedMeterNumber" : "5858584224475859193", "normalizedPointOfDeliveryNumber" : "8", "outstandingBalance" : 191.68, "periodEndDate" : "2023-09-24", "periodStartDate" : "2023-08-25", "pointOfDeliveryNumber" : "8", "previousReadDate" : "2023-08-25", "serviceType" : "sewer", "serviceTypeClassification" : "CORE", "totalCharges" : 191.68, "totalUsage" : 311.47, "totalUsageUnit" : "kWh" }, { "amountDue" : 915.91, "currencyCode" : null, "meterId" : "mtr_48a824e6-05ac-c20c-f08d-9a8dea98d9c9", "meterNumber" : "9168898559626820383", "meterReadDate" : "2023-09-24", "normalizedMeterNumber" : "9168898559626820383", "normalizedPointOfDeliveryNumber" : "8", "outstandingBalance" : 915.91, "periodEndDate" : "2023-09-24", "periodStartDate" : "2023-08-25", "pointOfDeliveryNumber" : "8", "previousReadDate" : "2023-08-25", "serviceType" : "lighting", "serviceTypeClassification" : "CORE", "totalCharges" : 915.91, "totalUsage" : 600.16, "totalUsageUnit" : "kWh" } ], "normalizedAccountNumber" : "9101529173037918001", "outstandingBalance" : 1107.59, "provider" : { "classification" : "PUBLISHER", "id" : "prv_3ac39cf2-fdcf-5efd-1d98-0840559258ab", "name" : "Example Non-RTCV Provider", "publisherProviderAccountId" : "act_0b2eb6e4-1f53-86cb-9d30-6461536907d6" }, "totalCharges" : 1107.59 } ], "amountDue" : 1107.59, "businessUnitsIntersection" : [ { "id" : "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933", "name" : null } ], "businessUnitsUnion" : [ { "id" : "bus_f0dc4f28-c43e-8eb6-99a6-7d369b3ac933", "name" : null } ], "correlationIds" : [ "example-correlation-id" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "currencyCode" : null, "dataIngestionMethod" : "UTILITY_WEBSITE_ACCESS", "discoveredAt" : "2023-09-24T00:00:00.000+00:00", "discoveredStatementId" : "dss_5ce638b8-071d-88c6-f04e-6945e6912929", "dueDate" : "2023-10-08", "id" : "stm_c2a311fb-6109-5c87-2dde-19b81ce6aa60", "invoiceNumber" : "4407009208050897474", "isLatestVersion" : true, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "normalizedSummaryAccountNumber" : null, "outstandingBalance" : 1107.59, "periodEndDate" : "2023-09-24", "periodStartDate" : "2023-08-25", "provider" : { "country" : "USA", "id" : "prv_3ac39cf2-fdcf-5efd-1d98-0840559258ab", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : false, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : false, "name" : "Example Non-RTCV Provider" }, "statementDate" : "2023-09-24", "summaryAccountNumber" : null, "totalCharges" : 1107.59, "type" : "BILL", "versionId" : "stv_c4dac43f-7847-5896-a40c-b6c417ca141c" }, "errors" : [ ], "eventType" : "NEW_DATA_AVAILABLE", "id" : "whk_22d856af-2dc3-cf84-8818-9d05afbb619f", "resource" : "STATEMENT" }
Unsuccessful Non-RTCV Submission
- Credentials submitted
- Credential failure event emitted:
{ "businessUnitIds" : [ "bus_e3cf8615-c199-27ca-e945-de73c2d4e859" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e3cf8615-c199-27ca-e945-de73c2d4e859", "name" : null } ], "connectionHealth" : "CONNECTION_FAILURE", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_02743db5-7711-e955-d428-dea99ad7c135", "isAccessible" : false, "isActive" : true, "isCustomerActionRequired" : true, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_e019cc24-8628-d363-1bce-6d0d5ee1687e", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : false, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : false, "name" : "Example Non-RTCV Provider" }, "status" : "CONNECTION_FAILURE", "statusDetail" : "INVALID_CREDENTIALS", "totalAccounts" : 0, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_6c11d16f-f1c7-30de-5895-c58865bf3b96", "resource" : "CREDENTIAL" }
Successful MFA Submission
-
Credentials submitted
The following events are only emitted if the credential was submitted using"isInteractive": truefor a credential or provider that requires MFA, via the create credential endpoint -
MFA methods event emitted:
{ "businessUnitIds" : [ "bus_4d6767b6-aebf-c867-fec8-80a934047735" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_4d6767b6-aebf-c867-fec8-80a934047735", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_023245ff-46b6-5cc7-b820-ea53fe9e6473", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_a9a518b1-629c-f5e0-b6b6-5b74d0f5b28c", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "verificationMethods" : [ { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "text" }, { "identifier" : "2", "isResubmission" : false, "name" : "********@gmail.com", "type" : "email" } ] }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_METHOD", "id" : "whk_a991106b-1df2-45ab-6e56-ebc8af9bf95a", "resource" : "MFA_METHOD_PROMPT" } -
Method is selected via this endpoint
-
One-time passcode event emitted:
{ "businessUnitIds" : [ "bus_4d6767b6-aebf-c867-fec8-80a934047735" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_4d6767b6-aebf-c867-fec8-80a934047735", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_023245ff-46b6-5cc7-b820-ea53fe9e6473", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_a9a518b1-629c-f5e0-b6b6-5b74d0f5b28c", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : false, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_33e6d992-6f96-ab28-a4b4-e8d5b039c333", "resource" : "MFA_CODE_PROMPT" } -
Correct one-time passcode is submitted via this endpoint
-
Credential login event is emitted:
{ "businessUnitIds" : [ "bus_4d6767b6-aebf-c867-fec8-80a934047735" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_4d6767b6-aebf-c867-fec8-80a934047735", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_023245ff-46b6-5cc7-b820-ea53fe9e6473", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_a9a518b1-629c-f5e0-b6b6-5b74d0f5b28c", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS", "id" : "whk_886a1611-d13e-e22f-5df3-890c869120d4", "resource" : "CREDENTIAL" }The remaining webhooks in this section are always emitted as long as webhooks are configured for your organization -
Credential event emitted:
{ "businessUnitIds" : [ "bus_4d6767b6-aebf-c867-fec8-80a934047735" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_4d6767b6-aebf-c867-fec8-80a934047735", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_023245ff-46b6-5cc7-b820-ea53fe9e6473", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_a9a518b1-629c-f5e0-b6b6-5b74d0f5b28c", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_aa4542df-83a3-030b-e4a7-5e3c44436029", "resource" : "CREDENTIAL" } -
Normal data extraction proceeds
MFA submission with a reselected method
-
Credentials submitted
The following events are only emitted if the credential was submitted using"isInteractive": truefor a credential or provider that requires MFA, via the create credential endpoint -
MFA methods event emitted:
{ "businessUnitIds" : [ "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_50aa6168-788a-dfc2-9f28-7c0fff142c54", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3f3807b7-c8d6-2522-8024-98859aec0d2f", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "verificationMethods" : [ { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "text" }, { "identifier" : "2", "isResubmission" : false, "name" : "********@gmail.com", "type" : "email" } ] }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_METHOD", "id" : "whk_81b51875-1965-81ae-a7f7-5e3b39094e3c", "resource" : "MFA_METHOD_PROMPT" } -
Method is selected via this endpoint
-
One-time passcode event is emitted:
{ "businessUnitIds" : [ "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_50aa6168-788a-dfc2-9f28-7c0fff142c54", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3f3807b7-c8d6-2522-8024-98859aec0d2f", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : false, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_e5b653bf-47a1-b09f-0f1d-b7df2a015d09", "resource" : "MFA_CODE_PROMPT" } -
Method is reselected using
"isResubmission": truevia this endpoint -
One-time passcode event is emitted with the newly selected method:
{ "businessUnitIds" : [ "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_50aa6168-788a-dfc2-9f28-7c0fff142c54", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3f3807b7-c8d6-2522-8024-98859aec0d2f", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : false, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "********@gmail.com", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_8803b218-adc0-3ce2-695f-4eb58d48151d", "resource" : "MFA_CODE_PROMPT" } -
Correct one-time passcode is submitted via this endpoint
-
Credential login event emitted:
{ "businessUnitIds" : [ "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_50aa6168-788a-dfc2-9f28-7c0fff142c54", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3f3807b7-c8d6-2522-8024-98859aec0d2f", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS", "id" : "whk_7034d1ed-b4a5-319b-0d57-383ae2663678", "resource" : "CREDENTIAL" }The remaining webhooks in this section are always emitted as long as webhooks are configured for your organization -
Credential event emitted:
{ "businessUnitIds" : [ "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_e27c29de-e8f2-cca4-2ccb-bd1dcf4af43f", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_50aa6168-788a-dfc2-9f28-7c0fff142c54", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_3f3807b7-c8d6-2522-8024-98859aec0d2f", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_49c0dff0-5c56-7cfa-61da-734f5d5033a6", "resource" : "CREDENTIAL" } -
Normal data extraction proceeds
MFA submission with an invalid one-time passcode
-
Credentials submitted
The following events are only emitted if the credential was submitted using"isInteractive": truefor a credential or provider that requires MFA, via the create credential endpoint -
MFA methods event emitted:
{ "businessUnitIds" : [ "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_31f35d15-e539-098d-02b4-a498a0515c55", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_1fdddd7d-97a8-3806-5472-b348fb4b3ea5", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "verificationMethods" : [ { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "text" }, { "identifier" : "2", "isResubmission" : false, "name" : "********@gmail.com", "type" : "email" } ] }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_METHOD", "id" : "whk_83565ec0-0d29-b09d-3e41-0aae2eb54861", "resource" : "MFA_METHOD_PROMPT" } -
Method is selected via this endpoint
-
One-time passcode event is emitted:
{ "businessUnitIds" : [ "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_31f35d15-e539-098d-02b4-a498a0515c55", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_1fdddd7d-97a8-3806-5472-b348fb4b3ea5", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : false, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_e7d66d66-81b8-f73a-960b-6e7c4992b249", "resource" : "MFA_CODE_PROMPT" } -
Incorrect one-time passcode is submitted via this endpoint
-
One-time passcode event is emitted:
{ "businessUnitIds" : [ "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_31f35d15-e539-098d-02b4-a498a0515c55", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_1fdddd7d-97a8-3806-5472-b348fb4b3ea5", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : true, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_a8d93d1e-cb1e-09f2-f60c-797b0b1e76a2", "resource" : "MFA_CODE_PROMPT" } -
Correct one-time passcode is submitted via this endpoint
-
Credential login event emitted:
{ "businessUnitIds" : [ "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_31f35d15-e539-098d-02b4-a498a0515c55", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_1fdddd7d-97a8-3806-5472-b348fb4b3ea5", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "REAL_TIME_CREDENTIAL_VALIDATION_SUCCESS", "id" : "whk_3e9fed31-cba5-0895-f3de-0ad3d7e4e3b2", "resource" : "CREDENTIAL" }The remaining webhooks in this section are always emitted as long as webhooks are configured for your organization -
Credential event emitted:
{ "businessUnitIds" : [ "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_8f24d61a-e66c-5dd3-b817-52acbbb3838a", "name" : null } ], "connectionHealth" : "CONNECTION_SUCCESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_31f35d15-e539-098d-02b4-a498a0515c55", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_1fdddd7d-97a8-3806-5472-b348fb4b3ea5", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_SUCCESS", "statusDetail" : "LOGIN_AND_DATA_DISCOVERY_SUCCESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "errors" : [ ], "eventType" : "STATUS_CHANGE", "id" : "whk_d1619817-eb40-b358-e866-351cae6dc1a6", "resource" : "CREDENTIAL" } -
Normal data extraction proceeds
MFA Failure
-
Credentials submitted
The following events are only emitted if the credential was submitted using"isInteractive": truefor a credential or provider that requires MFA, via the create credential endpoint -
MFA methods event emitted:
{ "businessUnitIds" : [ "bus_76a3a6af-f515-f683-a23c-764d6e9e917b" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_76a3a6af-f515-f683-a23c-764d6e9e917b", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_ccdeaca5-0b38-6925-2f9e-d58b2c545ddc", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_843b8007-785a-77f2-f14b-de2425e95c3a", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "verificationMethods" : [ { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "text" }, { "identifier" : "2", "isResubmission" : false, "name" : "********@gmail.com", "type" : "email" } ] }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_METHOD", "id" : "whk_e785c0a4-d2de-2b73-3b39-493272ddc378", "resource" : "MFA_METHOD_PROMPT" } -
Method is selected via this endpoint
-
One-time passcode event is emitted:
{ "businessUnitIds" : [ "bus_76a3a6af-f515-f683-a23c-764d6e9e917b" ], "createdAt" : "2024-02-21T00:00:00.000+00:00", "data" : { "credential" : { "alternateAccesses" : [ ], "businessUnitsUnion" : [ { "id" : "bus_76a3a6af-f515-f683-a23c-764d6e9e917b", "name" : null } ], "connectionHealth" : "CONNECTION_IN_PROGRESS", "correlationId" : "example-correlation-id", "createdAt" : "2024-02-21T00:00:00.000+00:00", "createdBy" : "[email protected]", "customerGivenWebsite" : "https://example.utility.com", "id" : "crd_ccdeaca5-0b38-6925-2f9e-d58b2c545ddc", "isAccessible" : true, "isActive" : true, "isCustomerActionRequired" : false, "isThirdPartyPortal" : false, "lastModifiedAt" : "2024-02-21T00:00:00.000+00:00", "lastModifiedBy" : "[email protected]", "lastSuccessfulMultiFactorAuthenticationOptOutAt" : null, "multiFactorAuthenticationOptOutStatus" : null, "nextScheduledAccountRunAt" : "2024-02-21T00:00:00.000+00:00", "provider" : { "country" : "USA", "id" : "prv_843b8007-785a-77f2-f14b-de2425e95c3a", "intervalServiceTypes" : [ ], "isIntervalDataSupported" : true, "isIntervalFileUploadSupported" : false, "isRealTimeCredentialValidationSupported" : true, "name" : "Example MFA Provider" }, "status" : "CONNECTION_IN_PROGRESS", "statusDetail" : "DATA_EXTRACTION_IN_PROGRESS", "totalAccounts" : 1, "username" : "example-username", "username2" : null, "username3" : null, "username4" : null, "website" : "https://example.provider.site" }, "isResubmission" : false, "selectedVerificationMethod" : { "identifier" : "1", "isResubmission" : false, "name" : "***-***-1234", "type" : "other" } }, "errors" : [ ], "eventType" : "MFA_CHALLENGE_CODE", "id" : "whk_d1db178d-62c8-11d0-c17c-2ecfaf907a9a", "resource" : "MFA_CODE_PROMPT" } -
Incorrect one-time passcode is submitted via this endpoint
-
One-time passcode event is emitted:
[...]
